<?

/*

  Virtual Freer

  http://freer.ir/virtual



  Copyright (c) 2011 Mohammad Hossein Beyram, freer.ir



  This program is free software; you can redistribute it and/or modify

  it under the terms of the GNU General Public License v3 (http://www.gnu.org/licenses/gpl-3.0.html)

  as published by the Free Software Foundation.

*/

//-- اطلاعات کلی پلاگین

$pluginData['packpay']['type'] = 'payment';

$pluginData['packpay']['name'] = 'پک پی';

$pluginData['packpay']['uniq'] = 'packpay';

$pluginData['packpay']['description'] = 'مخصوص پرداخت با دروازه پرداخت <a href="https://packpay.ir">پک پی</a>';

$pluginData['packpay']['author']['name'] = 'packpay';

$pluginData['packpay']['author']['url'] = 'https://packpay.ir';

$pluginData['packpay']['author']['email'] = 'd4rkky7@gmail.com';



//-- فیلدهای تنظیمات پلاگین

$pluginData['packpay']['field']['config']['1']['title'] = 'رفرش توکن';

$pluginData['packpay']['field']['config']['1']['name'] = 'refresh_token';

$pluginData['packpay']['field']['config']['2']['title'] = 'کلاینت ای دی';

$pluginData['packpay']['field']['config']['2']['name'] = 'client_id';

$pluginData['packpay']['field']['config']['3']['title'] = 'سکرت ای دی';

$pluginData['packpay']['field']['config']['3']['name'] = 'secret_id';

$pluginData['packpay']['field']['config']['4']['title'] = 'عنوان خرید';

$pluginData['packpay']['field']['config']['4']['name'] = 'title';



//-- تابع انتقال به دروازه پرداخت

function gateway__packpay($data)

{

	global $config, $db, $smarty;

	$refresh_token 	= trim($data['refresh_token']);

	$client_id 	= trim($data['client_id']);

	$secret_id 	= trim($data['secret_id']);

	$amount 		= $data['amount'];

	$invoice_id		= $data['invoice_id'];

	$callBackUrl 	= $data['callback'];

	$token_url = "https://dashboard.packpay.ir/oauth/token?grant_type=refresh_token&refresh_token=$refresh_token";

	$header = [];

	$body = [

		'refresh_token' => $refresh_token

	];

	$userPass = "$client_id:$secret_id";

	$token_data = http_post_request($body, $token_url, $header, $userPass);

	$header = [

		'authorization: ' . $token_data->token_type . ' ' . $token_data->access_token,

		'Accept: application/json'

	];



	$body = [

		"amount" => $amount,

		'callback_url' => $callBackUrl,

		'verify_on_request' => true

	];

	$url = "https://dashboard.packpay.ir/developers/bank/api/v1/purchase?amount=$amount" .

		"&callback_url=$callBackUrl&verify_on_request=true";

	$response = http_post_request($body, $url, $header);

	if ($response->status == 0) {

		// Hanlde Successful

		$update['payment_rand']		= $response->reference_code;

		$update['payment_status']		= 0;

		$sql = $db->queryUpdate('payment', $update, 'WHERE `payment_rand` = "' . $invoice_id . '" LIMIT 1;');

		$db->execute($sql);

		header('location:https://dashboard.packpay.ir/bank/purchase/send?RefId=' . $response->reference_code);

		exit;
	} else {

		// Error Handling 

		$data['title'] = 'خطای سیستم';

		$data['message'] = '<font color="red">در اتصال به درگاه پک پی مشکلی به وجود آمد٬ لطفا از درگاه سایر بانک‌ها استفاده نمایید.</font>' . $response->message . '<br /><a href="index.php" class="button">بازگشت</a>';

		$query	= 'SELECT * FROM `config` WHERE `config_id` = "1" LIMIT 1';

		$conf	= $db->fetch($query);

		$smarty->assign('config', $conf);

		$smarty->assign('data', $data);

		$smarty->display('message.tpl');
	}
}



function callback__packpay($data)

{

	global $db, $get;

	$reference_code = $get['reference_code'];

	$refresh_token 	= trim($data['refresh_token']);

	$client_id 	= trim($data['client_id']);

	$secret_id 	= trim($data['secret_id']);

	// Get Token		

	$token_url = "https://dashboard.packpay.ir/oauth/token?grant_type=refresh_token&refresh_token=$refresh_token";

	$header = [];

	$body = [

		'refresh_token' => $refresh_token

	];

	$userPass = "$client_id:$secret_id";

	$token_data = http_post_request($body, $token_url, $header, $userPass);



	// Verify refrence_code

	$sql 		= 'SELECT * FROM `payment` WHERE `payment_rand` = "' . $reference_code . '" LIMIT 1;';

	$payment 	= $db->fetch($sql);



	$header[] = 'Accept: application/json;charset=UTF-8';

	$url = "https://dashboard.packpay.ir/developers/bank/api/v1/purchase/verify?reference_code=$reference_code";

	$header[] = 'Authorization: Bearer ' . $token_data->access_token;



	$body = [

		"reference_code" => $reference_code

	];



	$result = http_post_request($body, $url, $header);

	if ($result->status == 0 && $result->message == 'successful') {

		$output['status']		= 1;

		$output['res_num']	= $reference_code;

		$output['ref_num']	= $reference_code;

		$output['payment_id']	= $payment['payment_id'];

		$update['payment_status'] = 1;

		$sql = $db->queryUpdate('payment', $update, 'WHERE `payment_rand` = "' . $reference_code . '" LIMIT 1;');

		$db->execute($sql);
	} else {

		$output['status']	= 0;

		$output['message'] = 'پرداخت با موفقیت انجام نشد.';
	}

	return $output;
}



function http_post_request($fields_arr, $url, $headers, $userPass = '')

{



	$fields_string = '';

	//url-ify the data for the POST



	$fields_string = json_encode($fields_arr);



	//open connection

	$ch = curl_init();



	//set the url, number of POST vars, POST data

	curl_setopt($ch, CURLOPT_URL, $url);

	curl_setopt($ch, CURLOPT_POST, 1);

	curl_setopt($ch, CURLOPT_POSTFIELDS, $fields_string);

	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

	if (count($headers)) {

		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	}

	if ($userPass) {

		curl_setopt($ch, CURLOPT_USERPWD, $userPass);
	}





	//execute post

	$res = curl_exec($ch);



	//close connection

	curl_close($ch);





	return json_decode($res);
}
